Index: Makefile
===================================================================
--- Makefile	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ Makefile	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -11,5 +11,5 @@
 # Program variables
 objects = account.o bitlbee.o chat.o crypting.o help.o ipc.o irc.o irc_commands.o nick.o query.o root_commands.o set.o storage.o $(STORAGE_OBJS) user.o
-headers = account.h bitlbee.h commands.h conf.h config.h crypting.h help.h ipc.h irc.h log.h nick.h query.h set.h sock.h storage.h user.h lib/events.h lib/http_client.h lib/ini.h lib/md5.h lib/misc.h lib/proxy.h lib/sha1.h lib/ssl_client.h lib/url.h protocols/nogaim.h
+headers = account.h bitlbee.h commands.h conf.h config.h crypting.h help.h ipc.h irc.h log.h nick.h otr.h query.h set.h sock.h storage.h user.h lib/events.h lib/http_client.h lib/ini.h lib/md5.h lib/misc.h lib/proxy.h lib/sha1.h lib/ssl_client.h lib/url.h protocols/nogaim.h
 subdirs = lib protocols
 
@@ -20,5 +20,5 @@
 OUTFILE=bitlbee.exe
 else
-objects += unix.o conf.o log.o
+objects += unix.o conf.o log.o otr.o
 OUTFILE=bitlbee
 endif
@@ -94,8 +94,10 @@
 	mkdir -p $(DESTDIR)$(ETCDIR)
 	install -m 0644 motd.txt $(DESTDIR)$(ETCDIR)/motd.txt
+	install -m 0644 welcome.txt $(DESTDIR)$(ETCDIR)/welcome.txt
 	install -m 0644 bitlbee.conf $(DESTDIR)$(ETCDIR)/bitlbee.conf
 
 uninstall-etc:
 	rm -f $(DESTDIR)$(ETCDIR)/motd.txt
+	rm -f $(DESTDIR)$(ETCDIR)/welcome.txt
 	rm -f $(DESTDIR)$(ETCDIR)/bitlbee.conf
 	-rmdir $(DESTDIR)$(ETCDIR)
Index: bitlbee.conf
===================================================================
--- bitlbee.conf	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ bitlbee.conf	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -85,4 +85,11 @@
 # MotdFile = /etc/bitlbee/motd.txt
 
+## WelcomeFile
+##
+## Specify an alternative file for the welcome message displayed when joining the
+## control channel. Default value depends on the --etcdir argument to configure.
+##
+# WelcomeFile = /etc/bitlbee/welcome.txt
+
 ## ConfigDir
 ##
Index: bitlbee.h
===================================================================
--- bitlbee.h	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ bitlbee.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -30,4 +30,7 @@
 #define _GNU_SOURCE /* Stupid GNU :-P */
 #endif
+
+/* Depend on Windows 2000 for now since we need getaddrinfo() */
+#define _WIN32_WINNT 0x0501
 
 /* Depend on Windows 2000 for now since we need getaddrinfo() */
@@ -141,4 +144,5 @@
 #include "misc.h"
 #include "proxy.h"
+#include "otr.h"
 
 typedef struct global {
@@ -152,4 +156,5 @@
 	char *helpfile;
 	int restart;
+	OtrlMessageAppOps otr_ops;   /* collects interface functions required by OTR */
 } global_t;
 
Index: conf.c
===================================================================
--- conf.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ conf.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -60,4 +60,5 @@
 	conf->pidfile = g_strdup( PIDFILE );
 	conf->motdfile = g_strdup( ETCDIR "/motd.txt" );
+	conf->welcomefile = g_strdup( ETCDIR "/welcome.txt" );
 	conf->ping_interval = 180;
 	conf->ping_timeout = 300;
@@ -258,4 +259,9 @@
 				conf->motdfile = g_strdup( ini->value );
 			}
+			else if( g_strcasecmp( ini->key, "welcomefile" ) == 0 )
+			{
+				g_free( conf->welcomefile );
+				conf->welcomefile = g_strdup( ini->value );
+			}
 			else if( g_strcasecmp( ini->key, "account_storage" ) == 0 )
 			{
Index: conf.h
===================================================================
--- conf.h	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ conf.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -45,4 +45,5 @@
 	char *pidfile;
 	char *motdfile;
+	char *welcomefile;
 	char *primary_storage;
 	char **migrate_storage;
Index: doc/README
===================================================================
--- doc/README	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ doc/README	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -67,4 +67,8 @@
 BitlBee's only real dependency is GLib. This is available on virtually every
 platform. Any recent version of GLib (2.4 or higher) will work.
+
+Off-the-Record encryption support will be included by default if the
+configure script finds libotr in one of the usual places. You can pass
+--otr=1 or --otr=0 to force it on or off, respectively.
 
 These days, MSN Messenger clients have to connect to the MS Passport servers
@@ -143,6 +147,6 @@
 
 
-A NOTE ON ENCRYPTION
-====================
+A NOTE ON PASSWORD ENCRYPTION
+=============================
 
 There used to be a note here about the simple obfuscation method used to
Index: ipc.c
===================================================================
--- ipc.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ ipc.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -33,4 +33,5 @@
 
 GSList *child_list = NULL;
+static char *statefile = NULL;
 
 static void ipc_master_cmd_client( irc_t *data, char **cmd )
@@ -62,23 +63,4 @@
 }
 
-static void ipc_master_cmd_deaf( irc_t *data, char **cmd )
-{
-	if( global.conf->runmode == RUNMODE_DAEMON )
-	{
-		b_event_remove( global.listen_watch_source_id );
-		close( global.listen_socket );
-		
-		global.listen_socket = global.listen_watch_source_id = -1;
-	
-		ipc_to_children_str( "OPERMSG :Closed listening socket, waiting "
-		                     "for all users to disconnect." );
-	}
-	else
-	{
-		ipc_to_children_str( "OPERMSG :The DEAF command only works in "
-		                     "normal daemon mode. Try DIE instead." );
-	}
-}
-
 void ipc_master_cmd_rehash( irc_t *data, char **cmd )
 {
@@ -116,5 +98,4 @@
 	{ "hello",      0, ipc_master_cmd_client,     0 },
 	{ "die",        0, ipc_master_cmd_die,        0 },
-	{ "deaf",       0, ipc_master_cmd_deaf,       0 },
 	{ "wallops",    1, NULL,                      IPC_CMD_TO_CHILDREN },
 	{ "wall",       1, NULL,                      IPC_CMD_TO_CHILDREN },
@@ -460,5 +441,4 @@
 }
 
-#ifndef _WIN32
 char *ipc_master_save_state()
 {
@@ -501,4 +481,9 @@
 }
 
+void ipc_master_set_statefile( char *fn )
+{
+	statefile = g_strdup( fn );
+}
+
 
 static gboolean new_ipc_client( gpointer data, gint serversock, b_input_condition cond )
@@ -521,4 +506,5 @@
 }
 
+#ifndef _WIN32
 int ipc_master_listen_socket()
 {
@@ -557,12 +543,8 @@
 }
 #else
-int ipc_master_listen_socket()
-{
 	/* FIXME: Open named pipe \\.\BITLBEE */
-	return 0;
-}
 #endif
 
-int ipc_master_load_state( char *statefile )
+int ipc_master_load_state()
 {
 	struct bitlbee_child *child;
@@ -572,5 +554,4 @@
 	if( statefile == NULL )
 		return 0;
-	
 	fp = fopen( statefile, "r" );
 	unlink( statefile );	/* Why do it later? :-) */
Index: ipc.h
===================================================================
--- ipc.h	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ ipc.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -58,5 +58,6 @@
 
 char *ipc_master_save_state();
-int ipc_master_load_state( char *statefile );
+void ipc_master_set_statefile( char *fn );
+int ipc_master_load_state();
 int ipc_master_listen_socket();
 
Index: irc.c
===================================================================
--- irc.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ irc.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -29,6 +29,9 @@
 #include "crypting.h"
 #include "ipc.h"
+#include <sys/types.h>
+#include <sys/wait.h>
 
 static gboolean irc_userping( gpointer _irc, int fd, b_input_condition cond );
+static void irc_welcome( irc_t* irc );
 
 GSList *irc_connection_list = NULL;
@@ -177,8 +180,8 @@
 
 	irc_connection_list = g_slist_append( irc_connection_list, irc );
+
 	
 	s = set_add( &irc->set, "away", NULL,  set_eval_away_status, irc );
 	s->flags |= SET_NULL_OK;
-	s = set_add( &irc->set, "away_devoice", "true",  set_eval_away_devoice, irc );
 	s = set_add( &irc->set, "auto_connect", "true", set_eval_bool, irc );
 	s = set_add( &irc->set, "auto_reconnect", "true", set_eval_bool, irc );
@@ -187,4 +190,5 @@
 	s = set_add( &irc->set, "buddy_sendbuffer_delay", "200", set_eval_int, irc );
 	s = set_add( &irc->set, "charset", "utf-8", set_eval_charset, irc );
+	s = set_add( &irc->set, "color_encrypted", "true", set_eval_bool, irc );
 	s = set_add( &irc->set, "control_channel", irc->channel, set_eval_control_channel, irc );
 	s = set_add( &irc->set, "debug", "false", set_eval_bool, irc );
@@ -193,6 +197,9 @@
 	s = set_add( &irc->set, "display_timestamps", "true", set_eval_bool, irc );
 	s = set_add( &irc->set, "handle_unknown", "root", NULL, irc );
+	s = set_add( &irc->set, "halfop_buddies", "encrypted", set_eval_halfop_buddies, irc );
 	s = set_add( &irc->set, "lcnicks", "true", set_eval_bool, irc );
-	s = set_add( &irc->set, "ops", "both", set_eval_ops, irc );
+	s = set_add( &irc->set, "op_buddies", "trusted", set_eval_op_buddies, irc );
+	s = set_add( &irc->set, "op_root", "true", set_eval_op_root, irc );
+	s = set_add( &irc->set, "otr_policy", "oppurtunistic", set_eval_otr_policy, irc );
 	s = set_add( &irc->set, "password", NULL, set_eval_password, irc );
 	s->flags |= SET_NULL_OK;
@@ -203,13 +210,14 @@
 	s = set_add( &irc->set, "show_offline", "false", set_eval_bool, irc );
 	s = set_add( &irc->set, "simulate_netsplit", "true", set_eval_bool, irc );
-	s = set_add( &irc->set, "status", NULL,  set_eval_away_status, irc );
-	s->flags |= SET_NULL_OK;
 	s = set_add( &irc->set, "strip_html", "true", NULL, irc );
 	s = set_add( &irc->set, "timezone", "local", set_eval_timezone, irc );
 	s = set_add( &irc->set, "to_char", ": ", set_eval_to_char, irc );
 	s = set_add( &irc->set, "typing_notice", "false", set_eval_bool, irc );
+	s = set_add( &irc->set, "voice_buddies", "notaway", set_eval_voice_buddies, irc);
 	
 	conf_loaddefaults( irc );
-	
+
+	irc->otr = otr_new();
+
 	/* Evaluator sets the iconv/oconv structures. */
 	set_eval_charset( set_find( &irc->set, "charset" ), set_getstr( &irc->set, "charset" ) );
@@ -363,7 +371,9 @@
 	
 	g_free( irc->last_target );
+
+	otr_free(irc->otr);
 	
 	g_free( irc );
-	
+
 	if( global.conf->runmode == RUNMODE_INETD ||
 	    global.conf->runmode == RUNMODE_FORKDAEMON ||
@@ -734,4 +744,38 @@
 } 
 
+const char *user_mode_prefix( irc_t *irc, user_t *u )
+{
+	static char op[] = "@";
+	static char halfop[] = "%";
+	static char voice[] = "+";
+	static char none[] = "";
+
+	int or = set_getbool(&irc->set, "op_root");
+	int ou = set_getbool(&irc->set, "op_user");
+	char *ob = set_getstr(&irc->set, "op_buddies");
+	char *hb = set_getstr(&irc->set, "halfop_buddies");
+	char *vb = set_getstr(&irc->set, "voice_buddies");
+
+	if( (!strcmp(u->nick, irc->mynick) && or) ||
+	    (!strcmp(u->nick, irc->nick) && ou) ||
+        (!u->away && !strcmp(ob, "notaway")) ||
+        (u->encrypted && !strcmp(ob, "encrypted")) ||
+        (u->encrypted>1 && !strcmp(ob, "trusted"))
+      )
+		return op;
+	else if( (!u->away && !strcmp(hb, "notaway")) ||
+             (u->encrypted && !strcmp(hb, "encrypted")) ||
+             (u->encrypted>1 && !strcmp(hb, "trusted"))
+	       )
+		return halfop;
+	else if( (!u->away && !strcmp(vb, "notaway")) ||
+             (u->encrypted && !strcmp(vb, "encrypted")) ||
+             (u->encrypted>1 && !strcmp(vb, "trusted"))
+	       )
+		return voice;
+	else
+		return none;
+}
+			
 void irc_names( irc_t *irc, char *channel )
 {
@@ -739,5 +783,4 @@
 	char namelist[385] = "";
 	struct groupchat *c = NULL;
-	char *ops = set_getstr( &irc->set, "ops" );
 	
 	/* RFCs say there is no error reply allowed on NAMES, so when the
@@ -754,10 +797,5 @@
 			}
 			
-			if( u->ic && !u->away && set_getbool( &irc->set, "away_devoice" ) )
-				strcat( namelist, "+" );
-			else if( ( strcmp( u->nick, irc->mynick ) == 0 && ( strcmp( ops, "root" ) == 0 || strcmp( ops, "both" ) == 0 ) ) ||
-			         ( strcmp( u->nick, irc->nick ) == 0 && ( strcmp( ops, "user" ) == 0 || strcmp( ops, "both" ) == 0 ) ) )
-				strcat( namelist, "@" );
-			
+			strcat( namelist, user_mode_prefix(irc, u) );
 			strcat( namelist, u->nick );
 			strcat( namelist, " " );
@@ -770,6 +808,6 @@
 		/* root and the user aren't in the channel userlist but should
 		   show up in /NAMES, so list them first: */
-		sprintf( namelist, "%s%s %s%s ", strcmp( ops, "root" ) == 0 || strcmp( ops, "both" ) ? "@" : "", irc->mynick,
-		                                 strcmp( ops, "user" ) == 0 || strcmp( ops, "both" ) ? "@" : "", irc->nick );
+		sprintf( namelist, "%s%s %s%s ", set_getbool(&irc->set, "op_root") ? "@" : "", irc->mynick,
+		                                 set_getbool(&irc->set, "op_user") ? "@" : "", irc->nick );
 		
 		for( l = c->in_room; l; l = l->next ) if( ( u = user_findhandle( c->ic, l->data ) ) )
@@ -781,4 +819,5 @@
 			}
 			
+			strcat( namelist, user_mode_prefix(irc, u) );
 			strcat( namelist, u->nick );
 			strcat( namelist, " " );
@@ -822,5 +861,5 @@
 	irc_reply( irc,   3, ":%s", IRCD_INFO );
 	irc_reply( irc,   4, "%s %s %s %s", irc->myhost, BITLBEE_VERSION, UMODES UMODES_PRIV, CMODES );
-	irc_reply( irc,   5, "PREFIX=(ov)@+ CHANTYPES=%s CHANMODES=,,,%s NICKLEN=%d NETWORK=BitlBee "
+	irc_reply( irc,   5, "PREFIX=(ohv)@%%+ CHANTYPES=%s CHANMODES=,,,%s NICKLEN=%d NETWORK=BitlBee "
 	                     "CASEMAPPING=rfc1459 MAXTARGETS=1 WATCH=128 :are supported by this server",
 	                     CTYPES, CMODES, MAX_NICK_LENGTH - 1 );
@@ -828,6 +867,5 @@
 	irc->umode[0] = '\0';
 	irc_umode_set( irc, "+" UMODE, 1 );
-
-	u = user_add( irc, irc->mynick );
+u = user_add( irc, irc->mynick );
 	u->host = g_strdup( irc->myhost );
 	u->realname = g_strdup( ROOT_FN );
@@ -851,10 +889,5 @@
 	irc_spawn( irc, u );
 	
-	irc_usermsg( irc, "Welcome to the BitlBee gateway!\n\n"
-	                  "If you've never used BitlBee before, please do read the help "
-	                  "information using the \x02help\x02 command. Lots of FAQs are "
-	                  "answered there.\n"
-	                  "If you already have an account on this server, just use the "
-	                  "\x02identify\x02 command to identify yourself." );
+	irc_welcome( irc );
 	
 	if( global.conf->runmode == RUNMODE_FORKDAEMON || global.conf->runmode == RUNMODE_DAEMON )
@@ -871,4 +904,33 @@
 		root_command( irc, send_cmd );
 		g_free( send_cmd[1] );
+	}
+}
+
+static void irc_welcome( irc_t *irc )
+{
+	FILE *f;
+	
+	f = fopen( global.conf->welcomefile, "r" );
+	if( !f )
+	{
+		irc_usermsg( irc, "Welcome to the BitlBee gateway!\n\n"
+	        	          "If you've never used BitlBee before, please do read the help "
+		                  "information using the \x02help\x02 command. Lots of FAQs are "
+		                  "answered there.\n"
+				  "OTR users please note: Private key files are owned by the user "
+				  "BitlBee is running as.\n"
+		                  "If you already have an account on this server, just use the "
+		                  "\x02identify\x02 command to identify yourself." );
+	}
+	else
+	{
+		char linebuf[380];
+		
+		while( fgets( linebuf, 380, f ) )
+		{
+			irc_usermsg( irc, linebuf );
+		}
+		
+		fclose( f );
 	}
 }
Index: irc.h
===================================================================
--- irc.h	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ irc.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -27,6 +27,8 @@
 #define _IRC_H
 
+#include "otr.h"
+
 #define IRC_MAX_LINE 512
-#define IRC_MAX_ARGS 8
+#define IRC_MAX_ARGS 16
 
 #define IRC_LOGIN_TIMEOUT 60
@@ -94,4 +96,6 @@
 	gint w_watch_source_id;
 	gint ping_source_id;
+	
+	otr_t *otr;            /* OTR state and book keeping */
 } irc_t;
 
Index: irc_commands.c
===================================================================
--- irc_commands.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ irc_commands.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -614,5 +614,4 @@
 	{ "completions", 0, irc_cmd_completions, IRC_CMD_LOGGED_IN },
 	{ "die",         0, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
-	{ "deaf",        0, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
 	{ "wallops",     1, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
 	{ "wall",        1, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
Index: lib/misc.c
===================================================================
--- lib/misc.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ lib/misc.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -157,4 +157,5 @@
 	char *s = out, *cs;
 	int i, matched;
+	int taglen;
 	
 	memset( out, 0, sizeof( out ) );
@@ -173,7 +174,16 @@
 				in ++;
 			
+			taglen = in-cs-1;   /* not <0 because the above loop runs at least once */
 			if( *in )
 			{
-				if( g_strncasecmp( cs+1, "br", 2) == 0 )
+				if( g_strncasecmp( cs+1, "b", taglen) == 0 )
+					*(s++) = '\x02';
+				else if( g_strncasecmp( cs+1, "/b", taglen) == 0 )
+					*(s++) = '\x02';
+				else if( g_strncasecmp( cs+1, "i", taglen) == 0 )
+					*(s++) = '\x1f';
+				else if( g_strncasecmp( cs+1, "/i", taglen) == 0 )
+					*(s++) = '\x1f';
+				else if( g_strncasecmp( cs+1, "br", 2) == 0 )
 					*(s++) = '\n';
 				in ++;
Index: lib/ssl_bogus.c
===================================================================
--- lib/ssl_bogus.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ lib/ssl_bogus.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -27,4 +27,8 @@
 
 int ssl_errno;
+
+void ssl_init( void )
+{
+}
 
 void *ssl_connect( char *host, int port, ssl_input_function func, gpointer data )
@@ -66,2 +70,7 @@
 	return 0;
 }
+
+int ssl_pending( void *conn )
+{
+	return 0;
+}
Index: lib/ssl_client.h
===================================================================
--- lib/ssl_client.h	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ lib/ssl_client.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -47,4 +47,7 @@
 
 
+/* Perform any global initialization the SSL library might need. */
+G_MODULE_EXPORT void ssl_init( void );
+
 /* Connect to host:port, call the given function when the connection is
    ready to be used for SSL traffic. This is all done asynchronously, no
Index: lib/ssl_gnutls.c
===================================================================
--- lib/ssl_gnutls.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ lib/ssl_gnutls.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -60,4 +60,11 @@
 static gboolean ssl_handshake( gpointer data, gint source, b_input_condition cond );
 
+
+void ssl_init( void )
+{
+	gnutls_global_init();
+	initialized = TRUE;
+	atexit( gnutls_global_deinit );
+}
 
 void *ssl_connect( char *host, int port, ssl_input_function func, gpointer data )
@@ -122,7 +129,5 @@
 	if( !initialized )
 	{
-		gnutls_global_init();
-		initialized = TRUE;
-		atexit( gnutls_global_deinit );
+		ssl_init();
 	}
 	
Index: lib/ssl_nss.c
===================================================================
--- lib/ssl_nss.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ lib/ssl_nss.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -91,4 +91,12 @@
 
 
+void ssl_init( void )
+{
+	PR_Init( PR_SYSTEM_THREAD, PR_PRIORITY_NORMAL, 1);
+	NSS_NoDB_Init(NULL);
+	NSS_SetDomesticPolicy();
+	initialized = TRUE;
+}
+
 void *ssl_connect( char *host, int port, ssl_input_function func, gpointer data )
 {
@@ -107,7 +115,5 @@
 	if( !initialized )
 	{
-		PR_Init( PR_SYSTEM_THREAD, PR_PRIORITY_NORMAL, 1);
-		NSS_NoDB_Init(NULL);
-		NSS_SetDomesticPolicy();
+		ssl_init();
 	}
 
Index: lib/ssl_openssl.c
===================================================================
--- lib/ssl_openssl.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ lib/ssl_openssl.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -56,4 +56,10 @@
 static gboolean ssl_handshake( gpointer data, gint source, b_input_condition cond );
 
+
+void ssl_init( void )
+{
+	initialized = TRUE;
+	SSLeay_add_ssl_algorithms();
+}
 
 void *ssl_connect( char *host, int port, ssl_input_function func, gpointer data )
@@ -115,6 +121,5 @@
 	if( !initialized )
 	{
-		initialized = TRUE;
-		SSLeay_add_ssl_algorithms();
+		ssl_init();
 	}
 	
Index: log.c
===================================================================
--- log.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ log.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -30,8 +30,8 @@
 static log_t logoutput;
 
-static void log_null(int level, char *logmessage);
-static void log_irc(int level, char *logmessage);
-static void log_syslog(int level, char *logmessage);
-static void log_console(int level, char *logmessage);
+static void log_null(int level, const char *logmessage);
+static void log_irc(int level, const char *logmessage);
+static void log_syslog(int level, const char *logmessage);
+static void log_console(int level, const char *logmessage);
 
 void log_init(void) {
@@ -97,5 +97,5 @@
 }
 
-void log_message(int level, char *message, ... ) {
+void log_message(int level, const char *message, ... ) {
 
 	va_list ap;
@@ -122,5 +122,5 @@
 }
 
-void log_error(char *functionname) {
+void log_error(const char *functionname) {
 	log_message(LOGLVL_ERROR, "%s: %s", functionname, strerror(errno));
 	
@@ -128,9 +128,9 @@
 }
 
-static void log_null(int level, char *message) {
+static void log_null(int level, const char *message) {
 	return;
 }
 
-static void log_irc(int level, char *message) {
+static void log_irc(int level, const char *message) {
 	if(level == LOGLVL_ERROR)
 		irc_write_all(1, "ERROR :Error: %s", message);
@@ -147,5 +147,5 @@
 }
 
-static void log_syslog(int level, char *message) {
+static void log_syslog(int level, const char *message) {
 	if(level == LOGLVL_ERROR)
 		syslog(LOG_ERR, "%s", message);
@@ -161,5 +161,5 @@
 }
 
-static void log_console(int level, char *message) {
+static void log_console(int level, const char *message) {
 	if(level == LOGLVL_ERROR)
 		fprintf(stderr, "Error: %s\n", message);
Index: log.h
===================================================================
--- log.h	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ log.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -44,9 +44,9 @@
 
 typedef struct log_t {
-	void (*error)(int level, char *logmessage);
-	void (*warning)(int level, char *logmessage); 
-	void (*informational)(int level, char *logmessage);
+	void (*error)(int level, const char *logmessage);
+	void (*warning)(int level, const char *logmessage); 
+	void (*informational)(int level, const char *logmessage);
 #ifdef DEBUG
-	void (*debug)(int level, char *logmessage);
+	void (*debug)(int level, const char *logmessage);
 #endif
 } log_t;
@@ -54,6 +54,6 @@
 void log_init(void);
 void log_link(int level, int output);
-void log_message(int level, char *message, ...) G_GNUC_PRINTF( 2, 3 );
-void log_error(char *functionname);
+void log_message(int level, const char *message, ...) G_GNUC_PRINTF( 2, 3 );
+void log_error(const char *functionname);
 
 #endif
